/*
 * 
 *  dynamic linker command file
 *  generated: Wed Jan 12 16:05:40 2000
 *  kernel   : legOS
 *  app start: 0xa1f6
 * 
 *  legOS - the independent LEGO Mindstorms OS
 *  (c) 1999 by Markus L. Noga <markus@noga.de>    
 * 
 */

OUTPUT_FORMAT("symbolsrec")
OUTPUT_ARCH(h8300)
ENTRY("_main")

MEMORY {
  rom   : o = 0x0000, l = 0x8000
  kern  : o = 0x8000, l = 0x21f6
  ram   : o = 0xa1f6, l = 0x5d06
  stack : o = 0xfefc, l = 0x0004
  eight : o = 0xff00, l = 0x0100
}

SECTIONS {

  .rom : {
    /* used rom functions */
    
    _rom_reset_vector = 0x0000;
        
    _reset        = 0x03ae ;
    lcd_show      = 0x1b62 ;
    lcd_hide      = 0x1e4a ;
    lcd_number    = 0x1ff2 ;
    lcd_clear     = 0x27ac ;
    lcd_refresh   = 0x27c8 ;
    power_init    = 0x2964 ;
    sound_system  = 0x299a ;
    power_off     = 0x2a62 ;
    sound_playing = 0x3ccc ;

    _rom_dummy_handler   = 0x046a ;
    _rom_ocia_handler    = 0x04cc ;
    _rom_ocia_return     = 0x04d4 ;
    
  } > rom

  .kernel :	{
    /* kernel symbols (relative to 0x8000) */
    
    _kmain = 0x0000 ;
    _mm_try_join = 0x00d0 ;
    _mm_update_first_free = 0x0100 ;
    _mm_init = 0x0126 ;
    _malloc = 0x01b0 ;
    _free = 0x0256 ;
    _calloc = 0x0280 ;
    _mm_reaper = 0x02a8 ;
    _systime_handler = 0x0314 ;
    _systime_tm_return = 0x0378 ;
    _systime_init = 0x0388 ;
    _systime_shutdown = 0x03d2 ;
    _systime_set_switcher = 0x03da ;
    _systime_set_timeslice = 0x03e0 ;
    _tm_switcher = 0x03f6 ;
    _tm_scheduler = 0x0412 ;
    _yield = 0x05ec ;
    _tm_init = 0x060a ;
    _tm_start = 0x064c ;
    _execi = 0x065c ;
    _exit = 0x07e2 ;
    _wait_event = 0x07f8 ;
    _msleep = 0x0860 ;
    _sleep = 0x0882 ;
    _kill = 0x08a0 ;
    _killall = 0x08dc ;
    _sem_event_wait = 0x0946 ;
    _sem_wait = 0x095e ;
    _sem_trywait = 0x097e ;
    _sem_post = 0x0996 ;
    _delay = 0x09a6 ;
    _cputc_native = 0x09c0 ;
    _cputc_native_0 = 0x09f2 ;
    _cputc_native_1 = 0x0a2a ;
    _cputc_native_2 = 0x0a62 ;
    _cputc_native_3 = 0x0a9a ;
    _cputc_native_4 = 0x0ace ;
    _cputc_native_5 = 0x0b02 ;
    _cputw = 0x0b0e ;
    _cputs = 0x0b48 ;
    _cls = 0x0b86 ;
    _lcd_number = 0x0ba8 ;
    _rx_handler = 0x0bbc ;
    _rx_core = 0x0bd0 ;
    _rxerror_handler = 0x0c2a ;
    _rxerror_core = 0x0c3e ;
    _txend_handler = 0x0c72 ;
    _txend_core = 0x0c86 ;
    _tx_handler = 0x0c94 ;
    _tx_core = 0x0ca8 ;
    _lnp_logical_shutdown = 0x0cd0 ;
    _lnp_logical_init = 0x0cf0 ;
    _lnp_logical_write = 0x0da2 ;
    _lnp_integrity_write = 0x0e58 ;
    _lnp_addressing_write = 0x0e9e ;
    _lnp_receive_packet = 0x0efa ;
    _lnp_integrity_byte = 0x0f3e ;
    _lnp_integrity_reset = 0x0fda ;
    _lnp_integrity_reset_core = 0x0fee ;
    _lnp_timeout_reset = 0x1016 ;
    _lnp_timeout_reset_core = 0x102a ;
    _lnp_init = 0x1034 ;
    _lnp_integrity_active = 0x104e ;
    _lnp_timeout_set = 0x105a ;
    _program_valid = 0x1064 ;
    _key_handler = 0x1366 ;
    _program_init = 0x1468 ;
    _program_shutdown = 0x14ae ;
    _vis_handler = 0x14b8 ;
    _vis_core = 0x14cc ;
    _dkey_handler = 0x1524 ;
    _dkey_pressed = 0x1562 ;
    _dkey_released = 0x1570 ;
    _getchar = 0x1590 ;
    _dm_handler = 0x15b6 ;
    _dm_init = 0x15f4 ;
    _dm_shutdown = 0x15f8 ;
    _ds_rotation_set = 0x1626 ;
    _ds_rotation_handler = 0x1672 ;
    _ds_init = 0x1720 ;
    _ds_shutdown = 0x175e ;
    _dsound_handler = 0x177c ;
    _dsound_core = 0x1790 ;
    _dsound_init = 0x1890 ;
    _dsound_shutdown = 0x18a4 ;
    _dsound_stop = 0x18a8 ;
    _dsound_finished = 0x18c8 ;
    _vll_init = 0x18e2 ;
    _vll_stop = 0x199c ;
    _vll_send = 0x1a18 ;
    _memset = 0x1b68 ;
    _memcpy = 0x1b76 ;
    ___mulhi3 = 0x1b88 ;
    _hex_display_codes = 0x1bba ;
    _ascii_display_codes = 0x1bca ;
    _min_length = 0x1c5c ;
    _dm_a_pattern = 0x1c6e ;
    _dm_b_pattern = 0x1c72 ;
    _dm_c_pattern = 0x1c76 ;
    _vll_pulsewidth = 0x1d58 ;
    _firmware_string = 0x1d5a ;
    _etext = 0x1d5a ;
    _lcd_refresh_counter = 0x1d5e ;
    _lcd_refresh_period = 0x1d5f ;
    _lnp_timeout = 0x1d60 ;
    _dsound_system_sounds = 0x1d62 ;
    __edata = 0x1d64 ;
    _bss_start = 0x1d70 ;
    _mm_semaphore = 0x214a ;
    _mm_first_free = 0x214c ;
    _tm_timeslice = 0x2150 ;
    _tm_current_slice = 0x2151 ;
    _tm_switcher_vector = 0x2152 ;
    _sys_time = 0x2154 ;
    _pd_idle = 0x2160 ;
    _cpid = 0x2162 ;
    _nb_tasks = 0x2164 ;
    _priority_head = 0x2166 ;
    _pd_single = 0x2170 ;
    _task_sem = 0x2184 ;
    _tx_state = 0x2186 ;
    _lnp_integrity_handler = 0x2190 ;
    _lnp_timeout_counter = 0x2192 ;
    _lnp_addressing_handler = 0x21a0 ;
    _lnp_integrity_state = 0x21c0 ;
    _packet_len = 0x21c2 ;
    _cprog = 0x21c4 ;
    _packet_src = 0x21c6 ;
    _dkey_timer = 0x21c8 ;
    _dkey = 0x21c9 ;
    _dkey_multi = 0x21ca ;
    _dm_a = 0x21cc ;
    _dm_b = 0x21d0 ;
    _dm_c = 0x21d4 ;
    _ds_rotation = 0x21d8 ;
    _ds_channel = 0x21d9 ;
    _ds_rotations = 0x21e0 ;
    _ds_ignore = 0x21e6 ;
    _ds_activation = 0x21e7 ;
    _dsound_next_note = 0x21e8 ;
    _dsound_internote_ms = 0x21ea ;
    _dsound_16th_ms = 0x21ec ;
    _dsound_next_time = 0x21f0 ;
    _end = 0x21f4 ;
    _mm_start = 0x21f4 ;

    /* end of kernel symbols */
  }  > kern
      
  .text :	{
    ___text = . ;
    *(.text) 	      /* must start with text for clean entry */			
    *(.rodata)
    *(.strings)
    *(.vectors)       /* vectors region (dummy) */

    ___text_end = . ;
  }  > ram

  .tors : {
    ___ctors = . ;
    *(.ctors)
    ___ctors_end = . ;
    ___dtors = . ;
    *(.dtors)
    ___dtors_end = . ;
  }  > ram

  .data : {
    ___data = . ;
    *(.data)
    *(.tiny)
    ___data_end = . ;
  }  > ram

  .bss : {
    ___bss = . ;
    *(.bss)
    *(COMMON)
    ___bss_end = ALIGN(2) ;
  }  >ram

  .stack : {
    _stack = . ; 
    *(.stack)
  }  > topram

  .eight 0xff00: {
    *(.eight)

    /* on-chip module registers (relative to 0xff00) */

    _T_IER = 0x90 ;
    _T_CSR = 0x91 ;
    _T_CNT = 0x92 ;
    _T_OCRA = 0x94 ;
    _T_OCRB = 0x94 ;
    _T_CR = 0x96 ;
    _T_OCR = 0x97 ;
    _T_ICRA = 0x98 ;
    _T_ICRB = 0x9a ;
    _T_ICRC = 0x9c ;
    _T_ICRD = 0x9e ;
    _PORT1_PCR = 0xac ;
    _PORT2_PCR = 0xad ;
    _PORT3_PCR = 0xae ;
    _PORT1_DDR = 0xb0 ;
    _PORT2_DDR = 0xb1 ;
    _PORT1 = 0xb2 ;
    _PORT2 = 0xb3 ;
    _PORT3_DDR = 0xb4 ;
    _PORT4_DDR = 0xb5 ;
    _PORT3 = 0xb6 ;
    _PORT4 = 0xb7 ;
    _PORT5_DDR = 0xb8 ;
    _PORT6_DDR = 0xb9 ;
    _PORT5 = 0xba ;
    _PORT6 = 0xbb ;
    _PORT7 = 0xbe ;
    _STCR = 0xc3 ;
    _SYSCR = 0xc4 ;
    _T0_CR = 0xc8 ;
    _T0_CSR = 0xc9 ;
    _T0_CORA = 0xca ;
    _T0_CORB = 0xcb ;
    _T0_CNT = 0xcc ;
    _T1_CR = 0xd0 ;
    _T1_CSR = 0xd1 ;
    _T1_CORA = 0xd2 ;
    _T1_CORB = 0xd3 ;
    _T1_CNT = 0xd4 ;
    _S_MR = 0xd8 ;
    _S_BRR = 0xd9 ;
    _S_CR = 0xda ;
    _S_TDR = 0xdb ;
    _S_SR = 0xdc ;
    _S_RDR = 0xdd ;
    _AD_A = 0xe0 ;
    _AD_A_H = 0xe0 ;
    _AD_A_L = 0xe1 ;
    _AD_B = 0xe2 ;
    _AD_B_H = 0xe2 ;
    _AD_B_L = 0xe3 ;
    _AD_C = 0xe4 ;
    _AD_C_H = 0xe4 ;
    _AD_C_L = 0xe5 ;
    _AD_D = 0xe6 ;
    _AD_D_H = 0xe6 ;
    _AD_D_L = 0xe7 ;
    _AD_CSR = 0xe8 ;
    _AD_CR = 0xe9 ;
    
    /* end of on-chip module registers */
    
  }  > eight

  .stab 0 (NOLOAD) : {
    [ .stab ]
  }

  .stabstr 0 (NOLOAD) : {
    [ .stabstr ]
  }

} /* SECTIONS */
