/* $Id: vll.h,v 1.2 2000/01/13 00:07:23 bjj Exp $
 * 
 * Known VLL codes for the MicroScout and the Code Pilot.
 */

#ifndef __vll_h__
#define __vll_h__

extern void vll_init(volatile unsigned *sensor);
extern void vll_stop();
extern void vll_send(char code);

enum vll_microscout_codes {
	VLL_MS_FWD,
	VLL_MS_REV,
	VLL_MS_BEEP_1 = 4,
	VLL_MS_BEEP_2,
	VLL_MS_BEEP_3,
	VLL_MS_BEEP_4,
	VLL_MS_BEEP_5,
	VLL_MS_STOP = 10,
	VLL_MS_S_FWD_05 = 16,
	VLL_MS_S_FWD_1,
	VLL_MS_S_FWD_2,
	VLL_MS_S_FWD_5,
	VLL_MS_S_REV_05,
	VLL_MS_S_REV_1,
	VLL_MS_S_REV_2,
	VLL_MS_S_REV_5,
	VLL_MS_S_BEEP_1,
	VLL_MS_S_BEEP_2,
	VLL_MS_S_BEEP_3,
	VLL_MS_S_BEEP_4,
	VLL_MS_S_BEEP_5,
	VLL_MS_S_WAIT_FOR_LIGHT,
	VLL_MS_S_SEEK_LIGHT,
	VLL_MS_S_CODE,
	VLL_MS_S_KEEP_ALIVE,
	VLL_MS_RUN,
	VLL_MS_DELETE_SCRIPT,
	VLL_MS_NEXT = 70,
	VLL_MS_RESET,
};

enum vll_code_pilot_codes {
	VLL_CP_FWD,
	VLL_CP_REV,
	VLL_CP_SOUND_VALVE = 4,
	VLL_CP_SOUND_HELICOPTER,
	VLL_CP_SOUND_TRUCK,
	VLL_CP_SOUND_ROBOT,
	VLL_CP_SOUND_MACHINE,
	VLL_CP_MUTE,
	VLL_CP_STOP,
	VLL_CP_MOTOR_N_SOUND,
	VLL_CP_PRG_TRUCK,
	VLL_CP_PRG_WHEEL_DRIVER,
	VLL_CP_PRG_CRASH_BUGGY,
	VLL_CP_PRG_ROBOT,
	VLL_CP_TOUCH_IN = 97,
	VLL_CP_TOUCH_OUT,
	VLL_CP_TONE_C = 99,
	VLL_CP_TONE_C_SHARP,
	VLL_CP_TONE_D,
	VLL_CP_TONE_D_SHARP,
	VLL_CP_TONE_E,
	VLL_CP_TONE_F,
	VLL_CP_TONE_F_SHARP,
	VLL_CP_TONE_G,
	VLL_CP_TONE_G_SHARP,
	VLL_CP_TONE_A,
	VLL_CP_TONE_A_SHARP,
	VLL_CP_TONE_B,
	VLL_CP_TONE_HI_C,
	VLL_CP_NUMBER_0,
	VLL_CP_NUMBER_1,
	VLL_CP_NUMBER_2,
	VLL_CP_NUMBER_3,
	VLL_CP_NUMBER_4,
	VLL_CP_NUMBER_5,
	VLL_CP_NUMBER_6,
	VLL_CP_NUMBER_7,
	VLL_CP_NUMBER_8,
	VLL_CP_NUMBER_9,
	VLL_CP_DECIMAL_DOT,
	VLL_CP_RANDOM,
	VLL_CP_SPEED_LOW,
	VLL_CP_SPEED_MED,
	VLL_CP_SPEED_HI,
	VLL_CP_TACHO
};

/* These three are universal */
#define VLL_FWD	VLL_MS_FWD
#define VLL_REV VLL_MS_REV
#define VLL_STOP VLL_MS_STOP

#endif
